:- consult('../plnxt').

%Example 1.
start1 :-
	nxt_goal(my_robot,nxt_open),
	sleep(10),
	nxt_goal(my_robot,nxt_close).


%Example 2.
start2 :-
	nxt_open,
	sleep(10),
	nxt_close.


%Example 3.
start3 :-
	nxt_open,
	nxt_go_cm(300,40),
	nxt_go_cm(-300,40),
	sleep(3),
	nxt_close.


%Example 4
start4 :-
	nxt_open,
	nxt_go(300),
	nxt_go_cm(-300,40,force),
	sleep(3),
	nxt_close.


%Example 5.
start5 :-
	nxt_open,
	segment5,
	segment5,
	segment5,
	segment5,
	segment5,
	nxt_close.

segment5 :-
	nxt_light(Light),
	nxt_ultrasonic(Distance),
	nl,
	write('Light: '), write(Light),nl,
	write('Distance: '), write(Distance),nl,
	nxt_go_cm(300,20).


%Example 6.
start6 :-
	nxt_open,
	nxt_go_cm(300,80),
	timer_create(_,2,clap6),
	nxt_go_cm(-300,80),
	nxt_close.

clap6 :-
	nxt_pincer(open,force),
	sleep(1),
	nxt_pincer(close,force).


%Example 7.
start7 :-
	nxt_open,
	nxt_go(300),
	trigger_create(_,check_distance7,obstacle7).

check_distance7 :-
	nxt_ultrasonic(Value,force),
	Value < 20.

obstacle7 :-
	nxt_stop,
	nxt_close.


%Example 8.
start8 :-
	nxt_open,
	nxt_pincer(open),
	nxt_go(400),
	trigger_create(_,check_ball8,ball8).

check_ball8 :-
	nxt_touch(Value,force),
	Value = 1.

ball8 :-
	nxt_stop,
	nxt_pincer(close),
	nxt_rotate(400,180),
	trigger_create(_,check_distance8,wall8),
	nxt_go(400).

check_distance8 :-
	nxt_ultrasonic(Value,force),
	Value < 20.

wall8 :-
	nxt_stop,
	nxt_pincer(open),
	nxt_go_cm(-400,20),
	nxt_pincer(close),
	sleep(1),
	nxt_stop,
	nxt_close.

%Example 9.
start9 :-
	nxt_open,
	nxt_go(300),
	trigger_create(_,check_distance9,obstacle9).

check_distance9 :-
	nxt_ultrasonic(Value,force),
	Value < 25.

obstacle9 :-
	nxt_stop,
	nxt_go_cm(-300,25),
	Angle is 110 + random(140),
	nxt_rotate(200,Angle),
	nxt_go(300),
	trigger_create(_,check_distance9,obstacle9).

stop9 :-
	nxt_stop,
	nxt_close.


%Example 10.
start10 :-
	nxt_open,
	trigger_create_noreturn(_,clap10,go_backward_clapping10),
	segment10.

segment10 :-
	nxt_rotate(300,-90),
	nxt_go_cm(300,20),
	segment10.

clap10 :-
	nxt_sound(Value,force),
	Value > 55.

go_backward_clapping10 :-
	nxt_stop,
	nxt_go_cm(-300,40),
	nxt_pincer(open,force),
	sleep(1),
	nxt_pincer(close,force),
	sleep(1),
	nxt_pincer(open,force),
	sleep(1),
	nxt_pincer(close,force),
	wait_till(nxt_is_stopped),
	nxt_close.

%Example 11.
start11 :-
	nxt_open,
	trigger_create(_,nxt_touch(1,force),[nxt_stop,nxt_close]),
	trigger_create(_,clap11,pincer11,inf),
	nxt_go_cm(250,100).

clap11 :-
	nxt_sound(Value,force),
	Value > 55.

pincer11 :-
	nxt_pincer(open,force),
	sleep(1),
	nxt_pincer(close,force).

%Example 12.
start12 :-
	nxt_open,
	nxt_goal(current,segment12(12),square_move).

segment12(0) :- nxt_close.

segment12(M) :-
	N is M-1,
	nxt_rotate(300,-90),
	nxt_go_cm(300,20),
	segment12(N).

%Example 13.
start13 :-
	nxt_goal(my_robot,go_to_a_wall13),
	nxt_goal(joey,go_joey13).

go_to_a_wall13 :-
	nxt_open,
	trigger_create(_,check_distance13,wall13),
	nxt_go(300).

go_joey13 :-
	nxt_open,
	nxt_go(300).

stop_joey13 :-
	nxt_stop,
	nxt_close.

check_distance13 :-
	nxt_ultrasonic(Value,force),
	Value < 20.

wall13 :-
	nxt_stop,
	nxt_goal(joey,stop_joey13),
	nxt_close.
