%
%     Implementation by Piotr Hoownia <holownia@student.agh.edu.pl>
%
%     Copyright (C) 2006-9 by the HeKatE Project
%
%     PLNXT has been develped by the HeKatE Project, 
%     see http://hekate.ia.agh.edu.pl
%
%     This file is part of PLNXT.
%
%     PLNXT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
%
%     PLNXT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
%
%     You should have received a copy of the GNU General Public License
%     along with PLNXT.  If not, see <http://www.gnu.org/licenses/>.
%


:- thread_local nxt_current_robot/1,
	nxt_serial_device/1,
	nxt_actions_connection_type/1,
	nxt_sync_mode/1,
	nxt_readings/1,
	nxt_connected/0,
	nxt_robot/10.

:- use_module(lib/nxt_movement).
:- use_module(lib/nxt_sensomoto).
:- use_module(lib/threads).


%%%%%%%%%%%%%%
%%% CONFIG %%%
%%%%%%%%%%%%%%


%%%% EDIT BELOW %%%%

%%% Choose communication module.
%%% One and only of lines below should be uncommented.
:- use_module(lib/nxt_actions_serial).
%:- use_module(lib/nxt_actions_icommand).
%:- use_module(lib/nxt_actions_simulator).
%:- use_module(lib/nxt_actions_sockets).


%% Declare each robot! The first one by default may be controlled using console.

% nxt_robot_definition(Alias,Device,Conn_type,Sync_mode,Readings,WheelCircumference,AxleLenght,LeftMotor,RightMotor,PincerMotor,
%	      Reverse,TouchPort,SoundPort,LightPort,UltrasonicPort).
%
%	Alias - alias for a robot ('current' is not allowed).
%	Device - device used to connect with a robot.
%	Conn_type - type of connection, usb or bt for bluetooth.
%	Sync_mode - engines synchronization mode (on or off). It may be turned on if you use serial module only!
%	Readings - %FIXME
%	WheelCircumference - circumference of a robot wheel in cm. Standard NXT tire has 17.5 cm circumference.
%	AxleLength - distance between right and left wheel in cm.
%	LeftMotor - a port which a left motor is connected to (may be 'A', 'B' or 'C').
%	RightMotor - a port which a right motor is connected to (may be 'A', 'B' or 'C').
%	PincerMotor - a port which a additional motor is connected to (may be 'A', 'B' or 'C').
%	Reverse - if true, engines move in an oposite direction. NOT IMPLEMENTED!
%	TouchPort - a port wich a touch sensor is connected to (may be 'S1', 'S2', 'S3' or 'S4').
%	SoundPort - a port wich a touch sound is connected to (may be 'S1', 'S2', 'S3' or 'S4').
%	LightPort - a port wich a touch light is connected to (may be 'S1', 'S2', 'S3' or 'S4').
%	UltrasonicPort - a port wich a ultrasonic sensor is connected to (may be 'S1', 'S2', 'S3' or 'S4').

nxt_robot_definition(my_robot,'/dev/rfcomm0',bt,off,on_demand,17.5,11,'C','B','A',false,'S1','S2','S3','S4').
nxt_robot_definition(joey,'/dev/rfcomm8',bt,off,on_demand,17.5,11,'C','B','A',false,'S1','S2','S3','S4').


%%%% EDIT BELOW IF YOU ARE USING SIMULATOR MODULE.

% Sometimes it is hard to observe actions. You may slow them by setting time factor less than 1 or make them faster by setting it more than 1.
nxt_simulator_time_factor(0.25).


%%%% DO NOT EDIT BELOW!! %%%%

:- nxt_robot_definition(Alias,_,_,_,_,_,_,_,_,_,_,_,_,_,_),nxt_start_thread(Alias,true,console_control).
